<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPlanningInterfaceResult_V5 ArrayType
 * @subpackage Arrays
 */
class ArrayOfPlanningInterfaceResult_V5 extends AbstractStructArrayBase
{
    /**
     * The PlanningInterfaceResult_V5
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PlanningInterfaceResult_V5[]
     */
    public $PlanningInterfaceResult_V5;
    /**
     * Constructor method for ArrayOfPlanningInterfaceResult_V5
     * @uses ArrayOfPlanningInterfaceResult_V5::setPlanningInterfaceResult_V5()
     * @param \StructType\PlanningInterfaceResult_V5[] $planningInterfaceResult_V5
     */
    public function __construct(array $planningInterfaceResult_V5 = array())
    {
        $this
            ->setPlanningInterfaceResult_V5($planningInterfaceResult_V5);
    }
    /**
     * Get PlanningInterfaceResult_V5 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PlanningInterfaceResult_V5[]|null
     */
    public function getPlanningInterfaceResult_V5()
    {
        return isset($this->PlanningInterfaceResult_V5) ? $this->PlanningInterfaceResult_V5 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPlanningInterfaceResult_V5 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPlanningInterfaceResult_V5 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePlanningInterfaceResult_V5ForArrayConstraintsFromSetPlanningInterfaceResult_V5(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPlanningInterfaceResult_V5PlanningInterfaceResult_V5Item) {
            // validation for constraint: itemType
            if (!$arrayOfPlanningInterfaceResult_V5PlanningInterfaceResult_V5Item instanceof \StructType\PlanningInterfaceResult_V5) {
                $invalidValues[] = is_object($arrayOfPlanningInterfaceResult_V5PlanningInterfaceResult_V5Item) ? get_class($arrayOfPlanningInterfaceResult_V5PlanningInterfaceResult_V5Item) : sprintf('%s(%s)', gettype($arrayOfPlanningInterfaceResult_V5PlanningInterfaceResult_V5Item), var_export($arrayOfPlanningInterfaceResult_V5PlanningInterfaceResult_V5Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PlanningInterfaceResult_V5 property can only contain items of type \StructType\PlanningInterfaceResult_V5, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PlanningInterfaceResult_V5 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PlanningInterfaceResult_V5[] $planningInterfaceResult_V5
     * @return \ArrayType\ArrayOfPlanningInterfaceResult_V5
     */
    public function setPlanningInterfaceResult_V5(array $planningInterfaceResult_V5 = array())
    {
        // validation for constraint: array
        if ('' !== ($planningInterfaceResult_V5ArrayErrorMessage = self::validatePlanningInterfaceResult_V5ForArrayConstraintsFromSetPlanningInterfaceResult_V5($planningInterfaceResult_V5))) {
            throw new \InvalidArgumentException($planningInterfaceResult_V5ArrayErrorMessage, __LINE__);
        }
        if (is_null($planningInterfaceResult_V5) || (is_array($planningInterfaceResult_V5) && empty($planningInterfaceResult_V5))) {
            unset($this->PlanningInterfaceResult_V5);
        } else {
            $this->PlanningInterfaceResult_V5 = $planningInterfaceResult_V5;
        }
        return $this;
    }
    /**
     * Add item to PlanningInterfaceResult_V5 value
     * @throws \InvalidArgumentException
     * @param \StructType\PlanningInterfaceResult_V5 $item
     * @return \ArrayType\ArrayOfPlanningInterfaceResult_V5
     */
    public function addToPlanningInterfaceResult_V5(\StructType\PlanningInterfaceResult_V5 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PlanningInterfaceResult_V5) {
            throw new \InvalidArgumentException(sprintf('The PlanningInterfaceResult_V5 property can only contain items of type \StructType\PlanningInterfaceResult_V5, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PlanningInterfaceResult_V5[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PlanningInterfaceResult_V5|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PlanningInterfaceResult_V5|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PlanningInterfaceResult_V5|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PlanningInterfaceResult_V5|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PlanningInterfaceResult_V5|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PlanningInterfaceResult_V5
     */
    public function getAttributeName()
    {
        return 'PlanningInterfaceResult_V5';
    }
}
